diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/log.h ns-3.41/src/core/model/log.h
--- ns-3.40/src/core/model/log.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/log.h	2024-02-09 14:44:07.881790000 -0800
@@ -447,25 +447,11 @@
     /**
      * Write a function parameter on the output stream,
      * separating parameters after the first by `,` strings.
-     * Overload for arithmetic types (integral type or floating point type),
-     * enabling the parameter to be passed by value.
      *
      * \param [in] param The function parameter.
      * \return This ParameterLogger, so it's chainable.
      */
-    template <typename T, typename U = std::enable_if_t<std::is_arithmetic_v<T>>>
-    ParameterLogger& operator<<(T param);
-
-    /**
-     * Write a function parameter on the output stream,
-     * separating parameters after the first by `,` strings.
-     * Overload for non-arithmetic types, enabling the parameter
-     * to be passed by reference.
-     *
-     * \param [in] param The function parameter.
-     * \return This ParameterLogger, so it's chainable.
-     */
-    template <typename T, typename U = std::enable_if_t<!std::is_arithmetic_v<T>>>
+    template <typename T>
     ParameterLogger& operator<<(const T& param);
 
     /**
@@ -477,14 +463,6 @@
     template <typename T>
     ParameterLogger& operator<<(const std::vector<T>& vector);
 
-    /**
-     * Overload for C-strings.
-     *
-     * \param [in] param The C-string
-     * \return This ParameterLogger, so it's chainable.
-     */
-    ParameterLogger& operator<<(const char* param);
-
   private:
     /** Add `, ` before every parameter after the first. */
     void CommaRest();
@@ -493,21 +471,26 @@
     std::ostream& m_os; //!< Underlying output stream.
 };
 
-template <typename T, typename U>
-ParameterLogger&
-ParameterLogger::operator<<(T param)
-{
-    CommaRest();
-    m_os << param;
-    return *this;
-}
-
-template <typename T, typename U>
+template <typename T>
 ParameterLogger&
 ParameterLogger::operator<<(const T& param)
 {
     CommaRest();
-    m_os << param;
+
+    if constexpr (std::is_convertible_v<T, std::string>)
+    {
+        m_os << "\"" << param << "\"";
+    }
+    else if constexpr (std::is_arithmetic_v<T>)
+    {
+        // Use + unary operator to cast uint8_t / int8_t to uint32_t / int32_t, respectively
+        m_os << +param;
+    }
+    else
+    {
+        m_os << param;
+    }
+
     return *this;
 }
 
@@ -522,30 +505,6 @@
     return *this;
 }
 
-/**
- * Specialization for strings.
- * \param [in] param The function parameter.
- * \return This ParameterLogger, so it's chainable.
- */
-template <>
-ParameterLogger& ParameterLogger::operator<< <std::string>(const std::string& param);
-
-/**
- * Specialization for int8_t.
- * \param [in] param The function parameter.
- * \return This ParameterLogger, so it's chainable.
- */
-template <>
-ParameterLogger& ParameterLogger::operator<< <int8_t>(const int8_t param);
-
-/**
- * Specialization for uint8_t.
- * \param [in] param The function parameter.
- * \return This ParameterLogger, so it's chainable.
- */
-template <>
-ParameterLogger& ParameterLogger::operator<< <uint8_t>(const uint8_t param);
-
 } // namespace ns3
 
 /**@}*/ // \ingroup logging
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/log-macros-enabled.h ns-3.41/src/core/model/log-macros-enabled.h
--- ns-3.40/src/core/model/log-macros-enabled.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/log-macros-enabled.h	2024-02-09 14:44:07.881790000 -0800
@@ -189,7 +189,9 @@
             NS_LOG_APPEND_CONTEXT;                                                                 \
             NS_LOG_APPEND_FUNC_PREFIX;                                                             \
             NS_LOG_APPEND_LEVEL_PREFIX(level);                                                     \
+            auto flags = std::clog.setf(std::ios_base::boolalpha);                                 \
             std::clog << msg << std::endl;                                                         \
+            std::clog.flags(flags);                                                                \
         }                                                                                          \
     } while (false)
 
@@ -245,7 +247,9 @@
             NS_LOG_APPEND_NODE_PREFIX;                                                             \
             NS_LOG_APPEND_CONTEXT;                                                                 \
             std::clog << g_log.Name() << ":" << __FUNCTION__ << "(";                               \
+            auto flags = std::clog.setf(std::ios_base::boolalpha);                                 \
             ns3::ParameterLogger(std::clog) << parameters;                                         \
+            std::clog.flags(flags);                                                                \
             std::clog << ")" << std::endl;                                                         \
         }                                                                                          \
     } while (false)
@@ -261,7 +265,9 @@
     NS_LOG_CONDITION                                                                               \
     do                                                                                             \
     {                                                                                              \
+        auto flags = std::clog.setf(std::ios_base::boolalpha);                                     \
         std::clog << msg << std::endl;                                                             \
+        std::clog.flags(flags);                                                                    \
     } while (false)
 
 #endif /* NS3_LOG_ENABLE */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/matrix-array.h ns-3.41/src/core/model/matrix-array.h
--- ns-3.40/src/core/model/matrix-array.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/matrix-array.h	2024-02-09 14:44:07.881790000 -0800
@@ -83,7 +83,7 @@
 {
   public:
     // instruct the compiler to generate the default constructor
-    MatrixArray<T>() = default;
+    MatrixArray() = default;
     /**
      * \brief Constructor "pages" number of matrices that are of size "numRows"x"numCols",
      * and are initialized with all-zero elements.
@@ -92,25 +92,25 @@
      * \param numCols the number of columns
      * \param numPages the number of pages
      */
-    MatrixArray<T>(size_t numRows, size_t numCols = 1, size_t numPages = 1);
+    MatrixArray(size_t numRows, size_t numCols = 1, size_t numPages = 1);
     /**
      * \brief Constructor creates a single array of values.size () elements and 1 column,
      * and uses std::valarray<T> values to initialize the elements.
      * \param values std::valarray<T> that will be used to initialize elements of 1D array
      */
-    explicit MatrixArray<T>(const std::valarray<T>& values);
+    explicit MatrixArray(const std::valarray<T>& values);
     /**
      * \brief Constructor creates a single array of values.size () elements and 1 column,
      * and moves std::valarray<T> values to initialize the elements.
      * \param values std::valarray<T> that will be moved to initialize elements of 1D array
      */
-    MatrixArray<T>(std::valarray<T>&& values);
+    MatrixArray(std::valarray<T>&& values);
     /**
      * \brief Constructor creates a single array of values.size () elements and 1 column,
      * and uses std::vector<T> values to initialize the elements.
      * \param values std::vector<T> that will be used to initialize elements of 1D array
      */
-    explicit MatrixArray<T>(const std::vector<T>& values);
+    explicit MatrixArray(const std::vector<T>& values);
     /**
      * \brief Constructor creates a single matrix of numRows and numCols, and uses
      * std::valarray<T> values to initialize the elements.
@@ -118,7 +118,7 @@
      * \param numCols the number of columns
      * \param values std::valarray<T> that will be used to initialize elements of 3D array
      */
-    MatrixArray<T>(size_t numRows, size_t numCols, const std::valarray<T>& values);
+    MatrixArray(size_t numRows, size_t numCols, const std::valarray<T>& values);
     /**
      * \brief Constructor creates a single matrix of numRows and numCols, and moves
      * std::valarray<T> values to initialize the elements.
@@ -126,7 +126,7 @@
      * \param numCols the number of columns
      * \param values std::valarray<T> that will be moved to initialize elements of 3D array
      */
-    MatrixArray<T>(size_t numRows, size_t numCols, std::valarray<T>&& values);
+    MatrixArray(size_t numRows, size_t numCols, std::valarray<T>&& values);
     /**
      * \brief Constructor creates the array of numPages matrices of numRows x numCols dimensions,
      * and uses std::valarray<T> values to initialize all the elements.
@@ -135,7 +135,7 @@
      * \param numPages the number of pages
      * \param values std::valarray<T> that will be used to initialize elements of 3D array
      */
-    MatrixArray<T>(size_t numRows, size_t numCols, size_t numPages, const std::valarray<T>& values);
+    MatrixArray(size_t numRows, size_t numCols, size_t numPages, const std::valarray<T>& values);
     /**
      * \brief Constructor creates the array of numPages matrices of numRows x numCols dimensions,
      * and moves std::valarray<T> values to initialize all the elements.
@@ -144,49 +144,32 @@
      * \param numPages the number of pages
      * \param values std::valarray<T> that will be used to initialize elements of 3D array
      */
-    MatrixArray<T>(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values);
-    /** instruct the compiler to generate the implicitly declared destructor*/
-    ~MatrixArray<T>() override = default;
-    /** instruct the compiler to generate the implicitly declared copy constructor*/
-    MatrixArray<T>(const MatrixArray<T>&) = default;
-    /**
-     * \brief Copy assignment operator.
-     * Instruct the compiler to generate the implicitly declared copy assignment operator.
-     * \return a reference to the result of the assignment
-     */
-    MatrixArray<T>& operator=(const MatrixArray<T>&) = default;
-    /** instruct the compiler to generate the implicitly declared move constructor*/
-    MatrixArray<T>(MatrixArray<T>&&) = default;
-    /**
-     * \brief Move assignment operator.
-     * Instruct the compiler to generate the implicitly declared move assignment operator.
-     * \return a reference to the result of the assignment
-     */
-    MatrixArray<T>& operator=(MatrixArray<T>&&) = default;
+    MatrixArray(size_t numRows, size_t numCols, size_t numPages, std::valarray<T>&& values);
+
     /**
      * \brief Element-wise multiplication with a scalar value.
      * \param rhs is a scalar value of type T
      * \returns The matrix in which each element has been multiplied by the given
      * scalar value.
      */
-    MatrixArray<T> operator*(const T& rhs) const;
+    MatrixArray operator*(const T& rhs) const;
     /**
      * \brief operator+ definition for MatrixArray<T>.
      * \param rhs The rhs MatrixArray object
      * \returns The result of operator+ of this MatrixArray and rhs MatrixArray
      */
-    MatrixArray<T> operator+(const MatrixArray<T>& rhs) const;
+    MatrixArray operator+(const MatrixArray<T>& rhs) const;
     /**
      * \brief binary operator- definition for MatrixArray<T>.
      * \param rhs The rhs MatrixArray object
      * \returns The result of operator- of this MatrixArray and rhs MatrixArray
      */
-    MatrixArray<T> operator-(const MatrixArray<T>& rhs) const;
+    MatrixArray operator-(const MatrixArray<T>& rhs) const;
     /**
      * \brief unary operator- definition for MatrixArray<T>.
      * \return the result of the operator-
      */
-    MatrixArray<T> operator-() const;
+    MatrixArray operator-() const;
     /**
      * \brief Page-wise matrix multiplication.
      * This operator interprets the 3D array as an array of matrices,
@@ -198,14 +181,14 @@
      * \param rhs is another MatrixArray instance
      * \returns The array of results of matrix multiplications.
      */
-    MatrixArray<T> operator*(const MatrixArray<T>& rhs) const;
+    MatrixArray operator*(const MatrixArray<T>& rhs) const;
     /**
      * \brief This operator interprets the 3D array as an array of matrices,
      * and performs a linear algebra operation on each of the matrices (pages),
      * i.e., transposes the matrix or array of matrices definition for MatrixArray<T>.
      * \return The resulting MatrixArray composed of the array of transposed matrices.
      */
-    MatrixArray<T> Transpose() const;
+    MatrixArray Transpose() const;
     /**
      *\brief Multiply each matrix in the array by the left and the right matrix.
      * For each page of this MatrixArray the operation performed is
@@ -228,8 +211,8 @@
      * \returns Returns the result of the multiplication which is a 3D MatrixArray
      * with dimensions J x K x P as explained previously.
      */
-    MatrixArray<T> MultiplyByLeftAndRightMatrix(const MatrixArray<T>& lMatrix,
-                                                const MatrixArray<T>& rMatrix) const;
+    MatrixArray MultiplyByLeftAndRightMatrix(const MatrixArray<T>& lMatrix,
+                                             const MatrixArray<T>& rMatrix) const;
 
     using ValArray<T>::GetPagePtr;
     using ValArray<T>::EqualDims;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/nstime.h ns-3.41/src/core/model/nstime.h
--- ns-3.40/src/core/model/nstime.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/nstime.h	2024-02-09 14:44:07.881790000 -0800
@@ -271,9 +271,10 @@
      * - `d`  (days)
      * - `y`  (years)
      *
-     * There can be no white space between the numerical portion
-     * and the units.  Any otherwise malformed string causes a fatal error to
-     * occur.
+     * There must be no whitespace between the numerical portion
+     * and the unit. If the string only contains a number, it is treated as seconds.
+     * Any otherwise malformed string causes a fatal error to occur.
+     *
      * \param [in] s The string to parse into a Time
      */
     explicit Time(const std::string& s);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/ptr.h ns-3.41/src/core/model/ptr.h
--- ns-3.40/src/core/model/ptr.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/ptr.h	2024-02-09 14:44:07.881790000 -0800
@@ -21,7 +21,6 @@
 #define PTR_H
 
 #include "assert.h"
-#include "deprecated.h"
 
 #include <iostream>
 #include <stdint.h>
@@ -80,23 +79,6 @@
     /** The pointer. */
     T* m_ptr;
 
-    /**
-     * Helper to test for null pointer.
-     *
-     * \note This has been deprecated; \see operator bool() instead.
-     *
-     * This supports the "safe-bool" idiom, see `operator Tester * ()`
-     */
-    // Don't deprecate the class because the warning fires
-    // every time ptr.h is merely included, masking the real uses of Tester
-    // Leave the macro here so we can find this later to actually remove it.
-    class /* NS_DEPRECATED_3_37 ("see operator bool") */ Tester
-    {
-      public:
-        // Delete operator delete to avoid misuse
-        void operator delete(void*) = delete;
-    };
-
     /** Interoperate with const instances. */
     friend class Ptr<const T>;
 
@@ -198,23 +180,6 @@
     T& operator*();
 
     /**
-     * Test for non-NULL Ptr.
-     *
-     * \note This has been deprecated; \see operator bool() instead.
-     *
-     * This enables simple pointer checks like
-     * \code
-     *   Ptr<...> p = ...;
-     *   if (p) ...
-     * \endcode
-     * This also disables deleting a Ptr
-     *
-     * This supports the "safe-bool" idiom; see [More C++ Idioms/Safe
-     * bool](https://en.wikibooks.org/wiki/More_C%2B%2B_Idioms/Safe_bool)
-     */
-    NS_DEPRECATED_3_37("see operator bool")
-    operator Tester*() const;
-    /**
      * Test for non-NULL pointer.
      *
      * This enables simple pointer checks like
@@ -774,17 +739,6 @@
 }
 
 template <typename T>
-Ptr<T>::operator Tester*() const // NS_DEPRECATED_3_37
-{
-    if (m_ptr == 0)
-    {
-        return 0;
-    }
-    static Tester test;
-    return &test;
-}
-
-template <typename T>
 Ptr<T>::operator bool() const
 {
     return m_ptr != nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/random-variable-stream.cc ns-3.41/src/core/model/random-variable-stream.cc
--- ns-3.40/src/core/model/random-variable-stream.cc	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/random-variable-stream.cc	2024-02-09 14:44:07.881790000 -0800
@@ -1738,4 +1738,123 @@
     m_validated = true;
 }
 
+NS_OBJECT_ENSURE_REGISTERED(BinomialRandomVariable);
+
+TypeId
+BinomialRandomVariable::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::BinomialRandomVariable")
+            .SetParent<RandomVariableStream>()
+            .SetGroupName("Core")
+            .AddConstructor<BinomialRandomVariable>()
+            .AddAttribute("Trials",
+                          "The number of trials.",
+                          IntegerValue(10),
+                          MakeIntegerAccessor(&BinomialRandomVariable::m_trials),
+                          MakeIntegerChecker<uint32_t>(0))
+            .AddAttribute("Probability",
+                          "The probability of success in each trial.",
+                          DoubleValue(0.5),
+                          MakeDoubleAccessor(&BinomialRandomVariable::m_probability),
+                          MakeDoubleChecker<double>(0));
+    return tid;
+}
+
+BinomialRandomVariable::BinomialRandomVariable()
+{
+    // m_trials and m_probability are initialized after constructor by attributes
+    NS_LOG_FUNCTION(this);
+}
+
+double
+BinomialRandomVariable::GetValue(uint32_t trials, double probability)
+{
+    NS_LOG_FUNCTION(this << trials << probability);
+
+    double successes = 0;
+
+    for (uint32_t i = 0; i < trials; ++i)
+    {
+        double v = Peek()->RandU01();
+        if (IsAntithetic())
+        {
+            v = (1 - v);
+        }
+
+        if (v <= probability)
+        {
+            successes += 1;
+        }
+    }
+
+    return successes;
+}
+
+uint32_t
+BinomialRandomVariable::GetInteger(uint32_t trials, uint32_t probability)
+{
+    NS_LOG_FUNCTION(this << trials << probability);
+    return static_cast<uint32_t>(GetValue(trials, probability));
+}
+
+double
+BinomialRandomVariable::GetValue()
+{
+    NS_LOG_FUNCTION(this);
+    return GetValue(m_trials, m_probability);
+}
+
+NS_OBJECT_ENSURE_REGISTERED(BernoulliRandomVariable);
+
+TypeId
+BernoulliRandomVariable::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::BernoulliRandomVariable")
+            .SetParent<RandomVariableStream>()
+            .SetGroupName("Core")
+            .AddConstructor<BernoulliRandomVariable>()
+            .AddAttribute("Probability",
+                          "The probability of the random variable returning a value of 1.",
+                          DoubleValue(0.5),
+                          MakeDoubleAccessor(&BernoulliRandomVariable::m_probability),
+                          MakeDoubleChecker<double>(0));
+    return tid;
+}
+
+BernoulliRandomVariable::BernoulliRandomVariable()
+{
+    // m_probability is initialized after constructor by attributes
+    NS_LOG_FUNCTION(this);
+}
+
+double
+BernoulliRandomVariable::GetValue(double probability)
+{
+    NS_LOG_FUNCTION(this << probability);
+
+    double v = Peek()->RandU01();
+    if (IsAntithetic())
+    {
+        v = (1 - v);
+    }
+
+    return (v <= probability) ? 1.0 : 0.0;
+}
+
+uint32_t
+BernoulliRandomVariable::GetInteger(uint32_t probability)
+{
+    NS_LOG_FUNCTION(this << probability);
+    return static_cast<uint32_t>(GetValue(probability));
+}
+
+double
+BernoulliRandomVariable::GetValue()
+{
+    NS_LOG_FUNCTION(this);
+    return GetValue(m_probability);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/realtime-simulator-impl.cc ns-3.41/src/core/model/realtime-simulator-impl.cc
--- ns-3.40/src/core/model/realtime-simulator-impl.cc	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/realtime-simulator-impl.cc	2024-02-09 14:44:07.885789900 -0800
@@ -62,7 +62,8 @@
                 "SynchronizationMode",
                 "What to do if the simulation cannot keep up with real time.",
                 EnumValue(SYNC_BEST_EFFORT),
-                MakeEnumAccessor(&RealtimeSimulatorImpl::SetSynchronizationMode),
+                MakeEnumAccessor<SynchronizationMode>(
+                    &RealtimeSimulatorImpl::SetSynchronizationMode),
                 MakeEnumChecker(SYNC_BEST_EFFORT, "BestEffort", SYNC_HARD_LIMIT, "HardLimit"))
             .AddAttribute("HardLimit",
                           "Maximum acceptable real-time jitter (used in conjunction with "
@@ -453,16 +454,15 @@
             }
         }
 
-        if (!process)
+        if (process)
         {
-            // Sleep until signalled
-            tsNow = m_synchronizer->Synchronize(tsNow, tsDelay);
-
-            // Re-check event queue
-            continue;
+            ProcessOneEvent();
+        }
+        else
+        {
+            // Sleep until signalled and re-check event queue
+            m_synchronizer->Synchronize(tsNow, tsDelay);
         }
-
-        ProcessOneEvent();
     }
 
     //
@@ -498,11 +498,11 @@
     m_stop = true;
 }
 
-void
+EventId
 RealtimeSimulatorImpl::Stop(const Time& delay)
 {
     NS_LOG_FUNCTION(this << delay);
-    Simulator::Schedule(delay, &Simulator::Stop);
+    return Simulator::Schedule(delay, &Simulator::Stop);
 }
 
 //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/realtime-simulator-impl.h ns-3.41/src/core/model/realtime-simulator-impl.h
--- ns-3.40/src/core/model/realtime-simulator-impl.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/realtime-simulator-impl.h	2024-02-09 14:44:07.885789900 -0800
@@ -91,7 +91,7 @@
     void Destroy() override;
     bool IsFinished() const override;
     void Stop() override;
-    void Stop(const Time& delay) override;
+    EventId Stop(const Time& delay) override;
     EventId Schedule(const Time& delay, EventImpl* event) override;
     void ScheduleWithContext(uint32_t context, const Time& delay, EventImpl* event) override;
     EventId ScheduleNow(EventImpl* event) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/rng-stream.cc ns-3.41/src/core/model/rng-stream.cc
--- ns-3.40/src/core/model/rng-stream.cc	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/rng-stream.cc	2024-02-09 14:44:07.885789900 -0800
@@ -370,7 +370,7 @@
     m_currentState[5] = p2;
 
     /* Combination */
-    u = ((p1 > p2) ? (p1 - p2) * norm : (p1 - p2 + m1) * norm);
+    u = ((p1 > p2) ? (p1 - p2) * MRG32k3a::norm : (p1 - p2 + m1) * MRG32k3a::norm);
 
     return u;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/simulation-singleton.h ns-3.41/src/core/model/simulation-singleton.h
--- ns-3.40/src/core/model/simulation-singleton.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/simulation-singleton.h	2024-02-09 14:44:07.885789900 -0800
@@ -44,9 +44,9 @@
 {
   public:
     // Delete default constructor, copy constructor and assignment operator to avoid misuse
-    SimulationSingleton<T>() = delete;
-    SimulationSingleton<T>(const SimulationSingleton<T>&) = delete;
-    SimulationSingleton<T>& operator=(const SimulationSingleton<T>&) = delete;
+    SimulationSingleton() = delete;
+    SimulationSingleton(const SimulationSingleton<T>&) = delete;
+    SimulationSingleton& operator=(const SimulationSingleton<T>&) = delete;
 
     /**
      * Get a pointer to the singleton instance.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/simulator.cc ns-3.41/src/core/model/simulator.cc
--- ns-3.40/src/core/model/simulator.cc	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/simulator.cc	2024-02-09 14:44:07.885789900 -0800
@@ -54,6 +54,8 @@
 // of causing recursions leading to stack overflow
 NS_LOG_COMPONENT_DEFINE("Simulator");
 
+EventId Simulator::m_stopEvent;
+
 /**
  * \ingroup simulator
  * \anchor GlobalValueSimulatorImplementationType
@@ -188,11 +190,18 @@
     GetImpl()->Stop();
 }
 
-void
+EventId
 Simulator::Stop(const Time& delay)
 {
     NS_LOG_FUNCTION(delay);
-    GetImpl()->Stop(delay);
+    m_stopEvent = GetImpl()->Stop(delay);
+    return m_stopEvent;
+}
+
+EventId
+Simulator::GetStopEvent()
+{
+    return m_stopEvent;
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/simulator.h ns-3.41/src/core/model/simulator.h
--- ns-3.40/src/core/model/simulator.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/simulator.h	2024-02-09 14:44:07.885789900 -0800
@@ -166,8 +166,16 @@
      * or equal to the stop time.  The stop time is relative to the
      * current simulation time.
      * @param [in] delay The stop time, relative to the current time.
+     * @return The stop EventId.
      */
-    static void Stop(const Time& delay);
+    static EventId Stop(const Time& delay);
+
+    /**
+     * Returns the Stop Event, or an invalid event if the simulation
+     * does not have a scheduled stop time.
+     * @return The stop EventId.
+     */
+    static EventId GetStopEvent();
 
     /**
      * Get the current simulation context.
@@ -520,6 +528,11 @@
      */
     static EventId DoScheduleDestroy(EventImpl* event);
 
+    /**
+     * Stop event (if present)
+     */
+    static EventId m_stopEvent;
+
 }; // class Simulator
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/simulator-impl.h ns-3.41/src/core/model/simulator-impl.h
--- ns-3.40/src/core/model/simulator-impl.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/simulator-impl.h	2024-02-09 14:44:07.885789900 -0800
@@ -61,7 +61,7 @@
     /** \copydoc Simulator::Stop() */
     virtual void Stop() = 0;
     /** \copydoc Simulator::Stop(const Time&) */
-    virtual void Stop(const Time& delay) = 0;
+    virtual EventId Stop(const Time& delay) = 0;
     /** \copydoc Simulator::Schedule(const Time&,const Ptr<EventImpl>&) */
     virtual EventId Schedule(const Time& delay, EventImpl* event) = 0;
     /** \copydoc Simulator::ScheduleWithContext(uint32_t,const Time&,EventImpl*) */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/singleton.h ns-3.41/src/core/model/singleton.h
--- ns-3.40/src/core/model/singleton.h	2023-09-27 13:30:37.630839000 -0700
+++ ns-3.41/src/core/model/singleton.h	2024-02-09 14:44:07.885789900 -0800
@@ -61,8 +61,8 @@
 {
   public:
     // Delete copy constructor and assignment operator to avoid misuse
-    Singleton<T>(const Singleton<T>&) = delete;
-    Singleton<T>& operator=(const Singleton<T>&) = delete;
+    Singleton(const Singleton<T>&) = delete;
+    Singleton& operator=(const Singleton<T>&) = delete;
 
     /**
      * Get a pointer to the singleton instance.
@@ -76,12 +76,12 @@
 
   protected:
     /** Constructor. */
-    Singleton<T>()
+    Singleton()
     {
     }
 
     /** Destructor. */
-    virtual ~Singleton<T>()
+    virtual ~Singleton()
     {
     }
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/type-id.cc ns-3.41/src/core/model/type-id.cc
--- ns-3.40/src/core/model/type-id.cc	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/model/type-id.cc	2024-02-09 14:44:07.889790000 -0800
@@ -383,7 +383,8 @@
 {
     NS_LOG_FUNCTION(IID << name);
     // Type names are definitive: equal names are equal types
-    NS_ASSERT_MSG(m_namemap.count(name) == 0, "Trying to allocate twice the same uid: " << name);
+    NS_ABORT_MSG_UNLESS(m_namemap.count(name) == 0,
+                        "Trying to allocate twice the same uid: " << name);
 
     TypeId::hash_t hash = Hasher(name) & (~HashChainFlag);
     if (m_hashmap.count(hash) == 1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/model/uniform-random-bit-generator.h ns-3.41/src/core/model/uniform-random-bit-generator.h
--- ns-3.40/src/core/model/uniform-random-bit-generator.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/src/core/model/uniform-random-bit-generator.h	2024-02-09 14:44:07.889790000 -0800
@@ -0,0 +1,84 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+#ifndef UNIFORM_RANDOM_BIT_GENERATOR_H
+#define UNIFORM_RANDOM_BIT_GENERATOR_H
+
+#include "random-variable-stream.h"
+
+#include <limits>
+
+namespace ns3
+{
+
+/**
+ * Wraps a UniformRandomVariable into a class that meets the requirements of a
+ * UniformRandomBitGenerator as specified by the C++11 standard, thus allowing
+ * the usage of ns-3 style UniformRandomVariables as generators in the functions
+ * of the standard random library.
+ */
+class UniformRandomBitGenerator
+{
+  public:
+    UniformRandomBitGenerator()
+        : m_rv(CreateObject<UniformRandomVariable>())
+    {
+    }
+
+    /**
+     * \return the ns-3 style uniform random variable
+     */
+    Ptr<UniformRandomVariable> GetRv() const
+    {
+        return m_rv;
+    }
+
+    /// Typedef needed to meet requirements. Result type must be an unsigned integer type.
+    using result_type = uint32_t;
+
+    /**
+     * \return the smallest value that operator() may return
+     */
+    static constexpr result_type min()
+    {
+        return 0;
+    }
+
+    /**
+     * \return the largest value that operator() may return
+     */
+    static constexpr result_type max()
+    {
+        return std::numeric_limits<result_type>::max();
+    }
+
+    /**
+     * \return a value in the closed interval [min(), max()]
+     */
+    result_type operator()()
+    {
+        return m_rv->GetInteger(min(), max());
+    }
+
+  private:
+    Ptr<UniformRandomVariable> m_rv; //!< ns-3 style uniform random variable
+};
+
+} // namespace ns3
+
+#endif /* UNIFORM_RANDOM_BIT_GENERATOR_H */
